/****************************************************************************
*                             DMATASK.H
*      Header file for DMATASK.LIB
*
*              version                       : 1.A.
*              creation                      : 16.08.1999
*              last change                   : 16.08.1999
*              author                        : M. Sailer
*
*    (c) by SORCUS Computer GmbH Heidelberg 1999
****************************************************************************/
/****************************************************************************
*  Description: 
*		This header file defines data structures and constants 
*		used by DMATASK.LIB
****************************************************************************/
/****************************************************************************
*  history:
*        1.A. 16.08.1999 14:00; MS
*        - creation of the file
****************************************************************************/
#ifndef DMATASK_INCLUDED
#define DMATASK_INCLUDED

#ifndef __BORLANDC__
   #pragma pack(push, SORCPACK, 1)
#else
   #pragma option -a-
#endif

typedef ULONG ABSOLUTE_ADDR;

typedef struct _BUFFERLIST
{
	ABSOLUTE_ADDR	pNext;
	ABSOLUTE_ADDR	pData;
	ULONG			ulSize;
	ULONG			ulCount;
}
BUFFERLIST, *PBUFFERLIST;

typedef struct _DMAREQUEST
{
	ABSOLUTE_ADDR	pBufList;
	USHORT			usCallbTask;
	USHORT			usCallbFunc;
	ULONG			ulCallbParam;
}
DMAREQUEST, *PDMAREQUEST;

typedef struct _DMARESULT
{
	ABSOLUTE_ADDR	pBufList;
	ULONG			ulNumBytes;
	USHORT  		usReason;
	ULONG			ulCallbParam;
}
DMARESULT, *PDMARESULT;

#define	DEFAULT_DMA_TASKNUM		240

#define	DMATASK_PROGNO				0x602

#define REQUEST_TOPC	2
#define REQUEST_FROMPC	3

#ifndef __BORLANDC__
   #pragma pack(pop, SORCPACK)
#else
   #pragma option -a.
#endif

#define DMASRQ_COMPLETE			0x01CE
#define DMASRQ_NOMOREBUFFERS	0x02CE
#define DMASRQ_TIMEOUT			0x03CE
#define DMASRQ_SYNCERROR		0x04CE

#endif
